{ FoxClone
  Copyright (C) 2019, 2020 Andy Hardwick
  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.
  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.
  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
  Boston, MA 02110-1335, USA.
}
{-------------------------------------------------------------------------------
FOXCLONE
v15 - changing sfdisk dump to disk on clone check to a tmemorystream

need to check that all buffers are array of char if reading from tprocess
the clonecheck problem where buffer was a string

need to modify for non sdx disks so that add p1, p2 etc to the part mount point
info is in parted -l

need to modify clonecheck with optional param so that it can read info from
an sfdisk file as well as direct - reqd for a  file to disk clone

v17 - v16 has code headers for utilities, mainform and backup sorted, but not
completed with backup, last action on v16 was getting rid of totalblocks in the
drives record and modifying extended in second backup checkbox

v18 - v17 has most of backup unit sorted before trying to move event handlers into
the backup unit - tried and failed. finished tidying worked on clone put
grub into sep procedure.

v19 - time to sort restore and clone file to disk into same procedure. now all
working need to fix nvme drives and start with backup etc. of mbr disks
and sort out globals

v20 - working on backup restore on GPT and MBR, but problems with restore on
logical parts, 1st time fails, so used force option, this works but then ferens
wouldn't boot - couldn't mount sda5 which was the logical part with /home for
ferens. redid the restore and all was okay. partclone first time round is thinking
that the part is zero length in spite of manually checking with sfdisk that the
part table was restored okay and sda5 is not zero length.

v21 - to try and fix this problem. also have checked some of the code for nvme
drives but not all and have not checked cloning on mbr.

v22 - v21 tested with clone disk to disk on mbr drive and working. think backup/restore working okay
need to check about moving grubrestore before parttable restore and do further testing

need to modify backup and restore on completion to change progress form the same as clone disk to disk

v23 - think all working, now amending backup to show all parts inc. those not selected which would i
include extended and swap parts plus any user non-selected parts. this for consistency with restore
and clone

still need to do os-prober and want to dump output from sfdisk to terminal, also need to chop filename
strings on the other confirm windows.

os-prober done, sfdisk dumps to terminal, chop filename needs to be more elegant. tested against LUKs
encrypted install - minor mods to make it work, uses dd. Minor change to cancel backup - was getting
errors. changed folder name to foxclonexx.

fox icon is on project > project options

v24 - starting to move files to proper locations.
images moved to /usr/local/foxclone/
default folder changed to /tmp/
foxclone moved to /usr/local/sbin
what happened to the dump of sfdisk???  ah that is in restore
now rename foxclone24 folder

theme is miny y for icons, copied foxclone24.png into  /usr/share/icons/Mint-Y/apps
changed desktop application to this? no changed icon path in application.desktop to absolute
did not change desktop but menu okay so delete desktop and reinstate and okay

still not happy with icon

next job is to do polkit to remove sudo - not done, runs okay as is

v25
after testing with iso
spaces after overall in prog bar to reduce overall width - done
spaces in filenames need to grub and sfdisk as well - done
  done for backup
  done for restore
change mount points
move icons to /usr/share/pixmaps/foxclone - done
sorted out problem with note button not showing, now have separate notebtn objects for both
restore and clone
backup/restore/clone occuring over midnight so overall progress wrong.
what about ownership, back files showing as owner 999 - user #999 when backed up from stick
grub and log files showing as root.

need to remove ptable checkbox from the settings tab

Problem - did full backup file to disk clone and all went well except it complained that it couldnt
create swap and all but one part was showing errors in gparted, did clone from file again and all was
okay. Some parts were already mounted before the clone???   note, after clone did a reboot and it was
still showing the same problems.

should i check and umount anything on the target drive before cloning? if so how much work

v26 - adding writeln's to all utility functions and procedures to provide terminal output to help
fault finding

v27 - need to fix crashing on a drive with valid filesys but no part table. need to modify grub so
that it only saves and restores the space between beginning of drive and first partition, it may not
be at 1MB. add command line switch to turn debug output on/off

debug switch added
now deletes any drive records where part table type is loop
grub backup/restore modified - now only copies the space between the start of the drive and start of
the first partition. Checked - restored mbrfullbodhi to sda which was a gpt drive.
Partition table checkbox on settings page commented out. note - associated procedures have not been
deleted yet.

v30 - readdrives event handler for mainform added, startupform added. readdrives uses startupform to
display progress while parted, etc. are running.

V31 - need to fix the grub problem with cloning - it's trying to dd the whole drive. Also need to
fix problems with a hybrid mbr/uefi boot found by steve. Tested with hybrid mbr/uefi boot drive - no
problems found.

V32 - was looking at changed partprobe for 'blockdev --rereadpt', but found blockdev was returning
      blockdev: ioctl error on BLKRRPART: Device or resource busy
this because there was a mounted partition on the drive. unmount the partition and all okay, but
partprobe on the same device did not throw up any errors, so leave unchanged.

Sudo commands removed and the need for a modified sudoers to remove the need for a password also
removed. Now this should have been easy, generate a policy for foxclone and run foxclone as
pkexec foxclone. This worked for the first embedded command, parted, but could NOT get it to work
with mount. The partition would mount, but the code would never return from:
     BytesRead:= mntProcess.stderr.Read(buffer[1],length(buffer));
Didn't matter if I read stderr or output or increased the size of the buffer.

The solution was straightforward but longwinded - create a policy for EVERY terminal command requiring
root privelege. These are in /usr/share/polkit-1/actions/com.foxclone.foxclone.policy.
Modify code so instead of 'sudo command' it is 'pkexec command'. Run foxclone as foxclone. This has the
advantage that development and testing can continue in lazarus. With a 'pkexec foxclone' approach,
lazarus has to be run as root (create a policy for it and run it as 'pkexec startlazarus') with the
additional disadvantage that the source files end up being owned by root.

ValidFile added - checks if a file can be created on the backup destination, if not then the
destination is probably owned by root so cannot be used.

Mount point changed from /tmp to /media/foxclone

V33 - now runs foxclone as root, decided that flagging up a destination with 'permission denied' could
      still confuse a newbie. As root, it will backup to any destination irrespective of permissions.
      Did try removing embedded pkexec but ran into same problems as before with mount. Tried on
      lazarus forum - no helpful responses. Might seem like double counting but running foxclone as
      pkexec foxclone with all the embedded pkexec's in the code works.

      To run foxclone as root there are two scripts:

         foxclone : this points at foxroot
         foxroot : this points at foxcloneXX

      The polkit allowing foxclone to run as root is defined for foxroot. This way an updated version
      only has to change foxroot and foxcloneXX in /home/ubuntu/.local/sbin on the iso.

      Removed function validfile as no longer required.

      Added a check in TMainFm.BackSaveCK - at the file save dialog the user might select another
      drive/partition from the left pane. Now traps this with check that the drive/partition selected
      is the same as selected in the main window. Can't find a way to clear this pane.

      Code on quit button when checking what drives foxclone mounted was not deleting the mount folder.
      Now fixed.

      Changed mount point to /mnt/foxclone from /media/foxclone to stop nemo interfering on a deb install

V34 - nothing to stop the user trying to backup or clone to the boot drive on a deb install. Done.
      Found a post on the LM forum where a user had more than 10 partitions on a single drive. Done.

V35 - in previous versions a restore assumes that if the drive was on sda when the drive was backed up,
      it will still be on sda for the restore. This may not be the case, e.g. the mSATA with LM19.0 is
      normally on sdc, but today it is showing as sdd. Needs a check on a restore.

V36 - nvme drive with win10 and LM19.0 dual boot. The MS reserved partition is showing as ext4, should
      be unknown so that partclone will backup using dd. V35 tries backup with partclone.ext4 and hangs.
      procedure parted modified. Have checked with sfdisk and the GUID for the MS reserved partition is
      correctly reported, so the problem lies with parted.

V37 - V36 and earlier do not check the filesystem on the destination for a backup. If that filesystem is
      fat32 there is a 4GB file limit which can be easily exceeded. V37 checks the destination filesystem
      and automatically set split files - done in backbox4.

V38 - reported error on clone from file, stating that insufficient space on a 2TB drive when cloning from
      the backup of a 320GB drive. Additional debug code added to CloneCheck. Problem found, was using
      strtoint to convert sector sizes from strings to int, but should have used strtoint64 - fixed.
      Checked through rest of code, one other instance of strtoint changed to strtoint64.

V39 - as a result of the changes in V37, splitting backup files on a fat32 partition - found that a
      restore was hanging on a split file restore. Much earlier I'd quoted filenames to deal with spaces
      in filenames. The cat command used for a split file restore does not like quotes around filenames.

V40 - now includes drive serial number. Previous versions used the drive model name as the identifier
      when doing a restore. This could cause a problem if there are two IDENTICAL drives in a system,
      a restore might select the wrong drive. In V40 the backup gets the drive serial number (using
      either hdparm for sata drives or nvme for nvme drives) and saves it in the backup file. A restore
      now compares the drive model name AND serial number to identify the correct drive to restore to.
      For compatibility with backups generated with previous versions, if there is no serial number in
      the backup file, foxclone will still identify the drive by the model name.

V41 - now includes a drive with a loop partition table (=no partition table but a valid filesystem) in
      the drives record and displays in box1. Checking for this is now done in backbox1 - which will not
      allow a drive with a loop part table to be backed up. Warning message on not getting a serial #
      on a sata drive removed - comes up if a usb stick plugged in. Confusing some users. chopstr
      amended to chop the full path name at "/" working from the left for a "prettier" display.
      Checked for redundant variables in compilation and removed.
      foxclone41 = 22.2MB.
      project options > debugging, turn off "generate debugging for GDB"
      foxclone41 = 6.1MB. A big reduction.
      Note - previous checks on finding the boot drive failed - wouldn't find the boot drive if it was
      a usb stick (there is no sda1, for example, that mounts as /). Now checks for the drive mounted
      as /cdrom, new function introduced for this - IsBoot.
      Display order of partition information in backup checkboxes changed to provide the more
      meaningful information first, checked and did a restore - worked. Need to make this order
      consistent across all partition checkboxes, confirm windows and in backup/restore/clone.
      Significant change to data structures on restore so development stopped on V41 and these changes
      done in V42.
V42 - significant changes arising from replacing a simple text string of partition info in the TRestData
      record with the TRestPartData record. Allows flexibility in the display of partition info in
      check/listboxes.
      BorderStyle:= bsDialog added to all forms to stop resizing, maybe resizable windows in the future.
      Minor bug fixes.
      Procedure swap added to turn swap on and off, previously done in the iso and the deb, now foxclone
      switches swap off on start and switches it back on on close.
      Default compression level changed from 2 to 1.
V44 - mainform unit split up with all the procedures associated with each tab on the main form moved into
      separate inc files.
      verify tab created with unit verify with supporting procedures
      bug fixed on clone from file - was getting partnumbers wrong if the destination was nvme
      log button created and procedures to show log on all functions except backup
      by replacing 'time' with 'now' should have fixed the bug that it got the remaining time wrong if a
      backup, etc. started before midnight and finished after.
      clone from file, nvme or sd card to sata - getting partition names wrong - including a 'p', fixed.
V45 - bug fix, restore was adding additional 'p's to the pnumber on nvme pcie and sd cards.
V46 - bug fix, no quotes or escaping on saving grub = no file if spaces present and grubsize returning
      an integer which if the last partition starts around 1TB will be a negative number = no grub file
      on backup. Solution - change grubsize to int64.

-------------------------------------------------------------------------------}

program foxclone46;

{$mode objfpc}{$H+}

uses
  cthreads, Interfaces, Forms, mainform, progform, noteform, backup, restore,
  confform, clone, utilities, startupform, verify, sysutils;

{$R *.res}

begin
  //when run from a terminal with the options either -d or --dump this switches
  //on debug output to the terminal. Every utility procedure or function called will dump the
  //name and the parameters passed to the terminal
  if Application.HasOption('d', 'dump') then debug:= true else debug:= false;
  //switch on and off for testing within lazarus
  //debug:= true;
  SwapOn(false); //added on v42, turn off swap
  RequireDerivedFormResource:=True;
  Application.Scaled:=True;
  Application.Initialize;
  Application.CreateForm(TMainFm, MainFm);
  Application.Run;
  SwapOn(true); //turn swap back on
end.

